﻿using System;
using System.Diagnostics;

namespace HeuristicLab.Services.Hive.Common {
  public class LogFactory {
    public static ILogger GetLogger(string source) {
      return new Logger("HeuristicLab.Hive", source);
    }
  }

  public interface ILogger {
    void Log(string message);
    void Error(Exception e);
  }

  internal class Logger : ILogger {
    private EventLog log;

    public Logger(string name, string source) {
      //if (!EventLog.SourceExists(name)) {
      //  EventLog.CreateEventSource(source, name);
      //}
      //log = new EventLog(name);
      //log.Source = source;
    }

    public void Log(string message) {
      //log.WriteEntry(string.Format("{0} (AppDomain: {1}, Thread: {2})", message, AppDomain.CurrentDomain.Id, Thread.CurrentThread.ManagedThreadId), EventLogEntryType.Information);
    }

    public void Error(Exception e) {
      //log.WriteEntry(string.Format("{0} (AppDomain: {1}, Thread: {2})", e.Message, AppDomain.CurrentDomain.Id, Thread.CurrentThread.ManagedThreadId), EventLogEntryType.Error);
    }
  }
}